/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by http://code.google.com/p/protostuff/ ... DO NOT EDIT!
// Generated from protobuf

package org.apache.drill.exec.proto.beans;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import com.dyuproject.protostuff.GraphIOUtil;
import com.dyuproject.protostuff.Input;
import com.dyuproject.protostuff.Message;
import com.dyuproject.protostuff.Output;
import com.dyuproject.protostuff.Schema;

public final class SchemaMetadata implements Externalizable, Message<SchemaMetadata>, Schema<SchemaMetadata>
{

    public static Schema<SchemaMetadata> getSchema()
    {
        return DEFAULT_INSTANCE;
    }

    public static SchemaMetadata getDefaultInstance()
    {
        return DEFAULT_INSTANCE;
    }

    static final SchemaMetadata DEFAULT_INSTANCE = new SchemaMetadata();

    
    private String catalogName;
    private String schemaName;
    private String owner;
    private String type;
    private String mutable;

    public SchemaMetadata()
    {
        
    }

    // getters and setters

    // catalogName

    public String getCatalogName()
    {
        return catalogName;
    }

    public SchemaMetadata setCatalogName(String catalogName)
    {
        this.catalogName = catalogName;
        return this;
    }

    // schemaName

    public String getSchemaName()
    {
        return schemaName;
    }

    public SchemaMetadata setSchemaName(String schemaName)
    {
        this.schemaName = schemaName;
        return this;
    }

    // owner

    public String getOwner()
    {
        return owner;
    }

    public SchemaMetadata setOwner(String owner)
    {
        this.owner = owner;
        return this;
    }

    // type

    public String getType()
    {
        return type;
    }

    public SchemaMetadata setType(String type)
    {
        this.type = type;
        return this;
    }

    // mutable

    public String getMutable()
    {
        return mutable;
    }

    public SchemaMetadata setMutable(String mutable)
    {
        this.mutable = mutable;
        return this;
    }

    // java serialization

    public void readExternal(ObjectInput in) throws IOException
    {
        GraphIOUtil.mergeDelimitedFrom(in, this, this);
    }

    public void writeExternal(ObjectOutput out) throws IOException
    {
        GraphIOUtil.writeDelimitedTo(out, this, this);
    }

    // message method

    public Schema<SchemaMetadata> cachedSchema()
    {
        return DEFAULT_INSTANCE;
    }

    // schema methods

    public SchemaMetadata newMessage()
    {
        return new SchemaMetadata();
    }

    public Class<SchemaMetadata> typeClass()
    {
        return SchemaMetadata.class;
    }

    public String messageName()
    {
        return SchemaMetadata.class.getSimpleName();
    }

    public String messageFullName()
    {
        return SchemaMetadata.class.getName();
    }

    public boolean isInitialized(SchemaMetadata message)
    {
        return true;
    }

    public void mergeFrom(Input input, SchemaMetadata message) throws IOException
    {
        for(int number = input.readFieldNumber(this);; number = input.readFieldNumber(this))
        {
            switch(number)
            {
                case 0:
                    return;
                case 1:
                    message.catalogName = input.readString();
                    break;
                case 2:
                    message.schemaName = input.readString();
                    break;
                case 3:
                    message.owner = input.readString();
                    break;
                case 4:
                    message.type = input.readString();
                    break;
                case 5:
                    message.mutable = input.readString();
                    break;
                default:
                    input.handleUnknownField(number, this);
            }   
        }
    }


    public void writeTo(Output output, SchemaMetadata message) throws IOException
    {
        if(message.catalogName != null)
            output.writeString(1, message.catalogName, false);

        if(message.schemaName != null)
            output.writeString(2, message.schemaName, false);

        if(message.owner != null)
            output.writeString(3, message.owner, false);

        if(message.type != null)
            output.writeString(4, message.type, false);

        if(message.mutable != null)
            output.writeString(5, message.mutable, false);
    }

    public String getFieldName(int number)
    {
        switch(number)
        {
            case 1: return "catalogName";
            case 2: return "schemaName";
            case 3: return "owner";
            case 4: return "type";
            case 5: return "mutable";
            default: return null;
        }
    }

    public int getFieldNumber(String name)
    {
        final Integer number = __fieldMap.get(name);
        return number == null ? 0 : number.intValue();
    }

    private static final java.util.HashMap<String,Integer> __fieldMap = new java.util.HashMap<String,Integer>();
    static
    {
        __fieldMap.put("catalogName", 1);
        __fieldMap.put("schemaName", 2);
        __fieldMap.put("owner", 3);
        __fieldMap.put("type", 4);
        __fieldMap.put("mutable", 5);
    }
    
}
